﻿namespace SelfPropelledArtilleryUnit;
/// <summary>
/// Класс-сущность "Самоходная арт. установка "
/// </summary>
public class EntitySelfPropelledArtilleryUnit
{ 
    /// <summary>
    /// Скорость
    /// </summary>
    public int Speed { get; private set; }

    /// <summary>
    /// Вес
    /// </summary>
    public double Weight {  get; private set; }

    /// <summary>
    /// Основной цвет
    /// </summary>
    public Color BodyColor { get; private set; }

    /// <summary>
    /// Дополнительный цвет (для опциональных элементов)
    /// </summary>
    public Color AdditionalColor { get; private set; }

    /// <summary>
    /// Признак - Башня с орудием
    /// </summary>
    public bool TurretCannon { get; private set; }

    /// <summary>
    /// Признак - Залповая батарея сзади
    /// </summary>
    public bool LaunchBattery { get; private set; }

    /// <summary>
    /// Шаг перемещения артеллерийской установки
    /// </summary>
    public double Step => Speed * 100 / Weight;

    /// <summary>
    /// Инициализация полей объекта-класса Самоходная арт. установка
    /// </summary>
    /// <param name="speed">Скорость</param>
    /// <param name="weight">Вес автомобиля</param>
    /// <param name="bodyColor">Основной цвет</param>
    /// <param name="additionalColor">Дополнительный цвет</param>
    /// <param name="turretCannon">Башня с орудием</param>
    /// <param name="launchBattery">Залповая батарея сзади</param>
    public void Init(int speed, double weight, Color bodyColor, Color additionalColor, bool turretCannon, bool launchBattery)
    {
        Speed = speed;
        Weight = weight;
        BodyColor = bodyColor;
        AdditionalColor = additionalColor;
        TurretCannon = turretCannon;
        LaunchBattery = launchBattery;
    }
}

